package rition.backend.api.v1;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import rition.backend.annotation.WithRequestIdResponse;
import rition.backend.api.v1.dto.request.MetricDataUploadRequest;
import rition.backend.api.v1.dto.response.Response;
import rition.backend.service.MetricDataCollectingService;
import rition.common.data.dto.MetricDataDto;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/metric")
public class DataCollectingController {

    private final MetricDataCollectingService metricDataCollectingService;

    public DataCollectingController(MetricDataCollectingService metricDataCollectingService) {
        this.metricDataCollectingService = metricDataCollectingService;
    }

    @PostMapping("/put")
    @WithRequestIdResponse
    public Response<Object> putData(@RequestBody List<MetricDataUploadRequest> uploadDataList) {

        // dto转换
        MetricDataDto metricDataDto = new MetricDataDto();
        List<MetricDataDto.MetricData> dataList = uploadDataList.stream()
                .map(data -> MetricDataDto.MetricData.builder()
                        .metric(data.getMetric())
                        .value(data.getValue())
                        .timestamp(data.getTimestamp())
                        .tags(data.getTags())
                        .build())
                .toList();

        metricDataDto.setDataList(dataList);
        metricDataCollectingService.receiveData(metricDataDto);

        return Response.success();
    }
}
