package rition.service.collector.dao.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.Instant;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName("rition_record")
public class MetricRecordEntity {

    /**
     * 数据记录id
     */
    private Long id;

    /**
     * 云主机实例id
     */
    private String instanceId;

    /**
     * 数据项
     */
    private String item;

    /**
     * 数据值，统一使用字符串存储
     */
    private String value;

    /**
     * create_time
     */
    private Instant time;

    /**
     * update_time
     */
    private Instant updateTime;

    /**
     * status
     */
    private Integer status;

    public static class RecordValueTypes {
        public static final int STRING = 0;
        public static final int INTEGER = 1;
        public static final int FLOAT = 2;
        public static final int BOOLEAN = 3;
    }
}
